#!/bin/sh
echo custom entry point script, setting up containter 
if [ $NEXTCLOUD_INSTALL ]; then
  echo "********** INSTALLING ***************"
  if [[ ! -f /app/config/config.php ]]; then
    echo creating /var/www/data for user files
    mkdir -p /var/www/data
    chown www-data:www-data /var/www/data
    echo removing execute command in original entry point script
    sed -i '/exec "$@"/d' /entrypoint.sh
    echo starting base nextcloud entrypoint install
    . /entrypoint.sh php-fpm
    echo base install in official docker completed, listing /var/www/html
    ls -la /var/www/html
    echo continuing with custom install
    echo creating /user-files /app directorys for binding
    echo "<?php phpinfo(); ?>" > /var/www/html/phpinfo.php
    rsync -a --chown=host:host /var/www/html/ /app/
    rm -rf /var/www/html/*
    touch /var/www/data/.ocdata
    rsync -a --chown=host:host /var/www/data/ /user-files/
    rm -rf /var/www/data/*
    echo *********** DONE INSTALLING ******************""
   else
    echo /app directory already exists can not install over existing installation, use upgrade
    exit 2
  fi
fi

[[ ! -f /user-files/.ocdata ]] && echo Nextcloud not installed can not continue && exit 1

if [[ ${HOST_GROUP_ID} ]]; then
 echo changing host group id to ${HOST_GROUP_ID} 
  groupmod -g ${HOST_GROUP_ID} host
  chown -R :host /user-files /app
fi  
if [[ ${HOST_USER_ID} ]]; then
 echo changing host user id to ${HOST_USER_ID} 
  usermod -u ${HOST_USER_ID} host
  chown -R host: /user-files /app
fi 

echo binding /app to /var/www/html
bindfs --force-user=www-data --force-group=www-data --create-for-user=host --create-for-group=host --chown-ignore --chgrp-ignore /app /var/www/html
echo confirming mountpoint /var/www/html
mountpoint /var/www/html
if [[ $? -ne 0 ]]; then
  echo FATAL error unable to bin /app to /var/www/html
  exit 1
 else
  ls -la /var/www/html
fi
echo binding /user-files to /var/www/data
bindfs --force-user=www-data --force-group=www-data --create-for-user=host --create-for-group=host --chown-ignore --chgrp-ignore /user-files /var/www/data
echo confirming mountpoint /var/www/data 
mountpoint /var/www/data
if [[ $? -ne 0 ]]; then
  echo FATAL error unable to bin /app to /var/www/html
  exit 1
 else
  ls -la /var/www/data
fi
echo starting php-fpm
php-fpm

